def var l-result as logical no-undo.

/* tt1 */
def temp-table tt1
field f1 as character
field f2 as character
field f3 as int
field f4 as int.

create tt1.
assign f1 = "aa"
f2 = "bb"
f3 = 3
f4 = 4.

def buffer b1 for tt1.
def var hBuffer1 as handle.
hBuffer1 = buffer b1:handle.

/* tt2 */
def temp-table tt2
field f1 as character
field f2 as character
field f3 as int
field f4 as int.

create tt2.
assign tt2.f1 = "aa"
tt2.f2 = "bb"
tt2.f3 = 3
tt2.f4 = 4.

def buffer b2 for tt2.
def var hBuffer2 as handle.
hBuffer2 = buffer b2:handle.


/* tt3 */
def temp-table tt3
field f1 as character
field f2 as character
field f3 as int.

create tt3.
assign tt3.f1 = "aa"
tt3.f2 = "bb"
tt3.f3 = 3.

def buffer b3 for tt3.
def var hBuffer3 as handle.
hBuffer3 = buffer b3:handle.

/*test*/

hBuffer1:FIND-FIRST().
hBuffer2:FIND-FIRST().
hBuffer3:FIND-FIRST().

message "Test for usual compare 1 with 2".
l-result=hBuffer1:buffer-compare(hBuffer2).
message "Result:" string(l-result).

message "Test for (fields are different, 1 with 3)".
l-result=hBuffer1:buffer-compare(hBuffer3).
message "Result:" string(l-result).

message "Test for (fields are different, 3 with 1)".
l-result=hBuffer3:buffer-compare(hBuffer1).
message "Result:" string(l-result).

message "Test for (fields are different, 1 with 3 ignore field)".
l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "", "f1,f1").
message "Result:" string(l-result).


assign tt2.f1 = "aa"
tt2.f2 = "bb"
tt2.f3 = 3
tt2.f4 = 6.

l-result=hBuffer1:buffer-compare(hBuffer2).
message "Result no eq ints:" string(l-result).

assign tt2.f1 = "aA"
tt2.f2 = "bb"
tt2.f3 = 3
tt2.f4 = 4.

l-result=hBuffer1:buffer-compare(hBuffer2).
message "Result usual caps:" string(l-result).

l-result=hBuffer1:buffer-compare(hBuffer2, "binary").
message "Result caps with binary:" string(l-result).

l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive").
message "Result caps with case-sensitive:" string(l-result).

l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "f1").
message "Result caps with case-sensitive ignore f1 field:" string(l-result).

l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "f11").
message "Result caps with case-sensitive ignore f11 field:" string(l-result).


l-result=hBuffer1:buffer-compare(hBuffer3).
message "Result usual caps (fields are different):" string(l-result).

l-result=hBuffer1:buffer-compare(hBuffer3, "binary").
message "Result caps with binary(fields are different):" string(l-result).

l-result = hBuffer1:buffer-compare(hBuffer3, "case-sensitive").
message "Result caps with case-sensitive(fields are different):" string(l-result).

l-result = hBuffer1:buffer-compare(hBuffer3, "case-sensitive", "f1").
message "Result caps with case-sensitive ignore f1 field(fields are different):" string(l-result).

l-result = hBuffer1:buffer-compare(hBuffer3, "case-sensitive", "f11").
message "Result caps with case-sensitive ignore f11 field (fields are different):" string(l-result).

message "SPECIAL ERRORS".

message "Text for [case-sensitive], [], [        ,                    ]".
/*Pair with rrr failed to have a member in each table. (9034)*/
l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "", "        ,                      ").
message "Result:" string(l-result).

message "Text for [case-sensitive], [], [,]".
/*Pair with rrr failed to have a member in each table. (9034)*/
l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "", ",").
message "Result:" string(l-result).

message "Text for [case-sensitive], [], [f3,]".
/*Pair with rrr failed to have a member in each table. (9034)*/
l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "", "f3,").
message "Result:" string(l-result).

message "Text for [case-sensitive], [], [rrr, xxx]".
/*Pair with rrr failed to have a member in each table. (9034)*/
l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "", "rrr, xxx").
message "Result:" string(l-result).


message "Text for [case-sensitive], [], [rrr.bg, xxx]".
/*Pair with rrr failed to have a member in each table. (9034)*/
l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "", "rrr.bg, xxx").
message "Result:" string(l-result).

message "Text for [case-sensitive], [], [f1.aa, f2.aa]".
/*Pair with rrr failed to have a member in each table. (9034)*/
l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "", "f1.aa, f2.aa").
message "Result:" string(l-result).

message "Text for [case-sensitive], [], [12, 34]".
/*Pair with rrr failed to have a member in each table. (9034)*/
l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "", "12, 34").
message "Result:" string(l-result).

message "Text for [case-sensitive], [], [rrr, xxx, yyy]".
/*Pair with rrr failed to have a member in each table. (9034)*/
l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "", "rrr, xxx, yyy").
message "Result:" string(l-result).

message "Text for [case-sensitive], [], [f1, xxx]".
/*Pair with rrr failed to have a member in each table. (9034)*/
l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "", "f1, xxx").
message "Result:" string(l-result).

message "Text for [case-sensitive], [], [rrr, f2]".
/*Pair with rrr failed to have a member in each table. (9034)*/
l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "", "rrr, f2").
message "Result:" string(l-result).


message "Test for [case-sensitive], [], [rrr]".
/*Pairs list had too many pairs or odd number of entries. (9035)*/
l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "", "rrr").
message "Result:" string(l-result).

message "Test for [case-sensitive], [], []".
/*ignored*/
l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "", "").
message "Result:" string(l-result).

message "Test for [case-sensitive], [uuuuu, kkkkk, 123], []".
/*ignored*/
l-result = hBuffer1:buffer-compare(hBuffer2, "case-sensitive", "uuuuu, kkkkk, 123", "").
message "Result:" string(l-result).
